diff -ur mpd-5.6/src/radius.c mpd-5.6-lutz/src/radius.c
--- mpd-5.6/src/radius.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/radius.c	2013-05-03 22:05:22.000000000 +0200
@@ -1220,7 +1228,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_OUTPUT_OCTETS: %s", 
     	    auth->info.lnkname, str));
 	if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_OUTPUT_OCTETS, str) != 0) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_OUTPUT_OCTETS: %s", auth->info.lnkname,
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_OUTPUT_OCTETS: %s", auth->info.lnkname,
 		rad_strerror(auth->radius.handle)));
 	}
 	snprintf(str, sizeof(str), "%s:%llu",
@@ -1228,7 +1236,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_OUTPUT_PACKETS: %s", 
     	    auth->info.lnkname, str));
 	if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_OUTPUT_PACKETS, str) != 0) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_OUTPUT_PACKETS: %s", auth->info.lnkname,
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_OUTPUT_PACKETS: %s", auth->info.lnkname,
 		rad_strerror(auth->radius.handle)));
 	}
 	if (strcmp(ssr->name,auth->params.std_acct[1]) == 0) {
@@ -1241,7 +1249,7 @@
 	    if (rad_put_int(auth->radius.handle, RAD_ACCT_OUTPUT_OCTETS, ssr->Octets % MAX_U_INT32) != 0 ||
 		rad_put_int(auth->radius.handle, RAD_ACCT_OUTPUT_PACKETS, ssr->Packets) != 0 ||
 		rad_put_int(auth->radius.handle, RAD_ACCT_OUTPUT_GIGAWORDS, ssr->Octets / MAX_U_INT32) != 0) {
-    		    Log(LG_RADIUS, ("[%s] RADIUS: Put output stats: %s", auth->info.lnkname,
+    		    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put output stats: %s", auth->info.lnkname,
 			rad_strerror(auth->radius.handle)));
     		    return (RAD_NACK);
 	    }
@@ -1264,7 +1272,7 @@
 	auth->info.lnkname, auth->params.authname));
     n = rad_init_send_request(auth->radius.handle, &fd, &tv);
     if (n != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: rad_init_send_request failed: %d %s",
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_init_send_request failed: %d %s",
     	    auth->info.lnkname, n, rad_strerror(auth->radius.handle)));
         return (RAD_NACK);
     }
@@ -1282,7 +1290,7 @@
 	n = poll(fds,1,tv.tv_sec*1000+tv.tv_usec/1000);
 
 	if (n == -1) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: poll failed %s", auth->info.lnkname, 
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: poll failed %s", auth->info.lnkname, 
     		strerror(errno)));
     	    return (RAD_NACK);
 	}
@@ -1331,13 +1339,13 @@
     	    break;
 
 	case -1:
-    	    Log(LG_RADIUS, ("[%s] RADIUS: rad_send_request for user '%s' failed: %s",
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_send_request for user '%s' failed: %s",
     		auth->info.lnkname, auth->params.authname,
 		rad_strerror(auth->radius.handle)));
     	    return (RAD_NACK);
       
 	default:
-    	    Log(LG_RADIUS, ("[%s] RADIUS: rad_send_request: unexpected return value: %d", 
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_send_request: unexpected return value: %d", 
     		auth->info.lnkname, n));
     	    return (RAD_NACK);
     }
@@ -1462,7 +1470,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Get RAD_FRAMED_ROUTE: %s ",
 	  auth->info.lnkname, route));
 	if (!ParseRange(route, &range, ALLOW_IPV4)) {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Get RAD_FRAMED_ROUTE: Bad route \"%s\"",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Get RAD_FRAMED_ROUTE: Bad route \"%s\"",
 	    auth->info.lnkname, route));
 	  free(route);
 	  break;
@@ -1473,7 +1481,7 @@
 	j = 0;
 	SLIST_FOREACH(r1, &auth->params.routes, next) {
 	  if (!u_rangecompare(&r->dest, &r1->dest)) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Duplicate route %s",
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Duplicate route %s",
 		auth->info.lnkname, route));
 	    j = 1;
 	  }
@@ -1491,7 +1499,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Get RAD_FRAMED_IPV6_ROUTE: %s ",
 	  auth->info.lnkname, route));
 	if (!ParseRange(route, &range, ALLOW_IPV6)) {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Get RAD_FRAMED_IPV6_ROUTE: Bad route \"%s\"", auth->info.lnkname, route));
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Get RAD_FRAMED_IPV6_ROUTE: Bad route \"%s\"", auth->info.lnkname, route));
 	  free(route);
 	  break;
 	}
@@ -1501,7 +1509,7 @@
 	j = 0;
 	SLIST_FOREACH(r1, &auth->params.routes, next) {
 	  if (!u_rangecompare(&r->dest, &r1->dest)) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Duplicate route %s",
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Duplicate route %s",
 		auth->info.lnkname, route));
 	    j = 1;
 	  }
@@ -1537,7 +1545,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Get RAD_FRAMED_MTU: %u ",
 	  auth->info.lnkname, i));
 	if (i < IFACE_MIN_MTU || i > IFACE_MAX_MTU) {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Get RAD_FRAMED_MTU: invalid MTU: %u ",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Get RAD_FRAMED_MTU: invalid MTU: %u ",
 	    auth->info.lnkname, i));
 	  auth->params.mtu = 0;
 	  break;
@@ -1594,7 +1602,7 @@
 
       case RAD_VENDOR_SPECIFIC:
 	if ((res = rad_get_vendor_attr(&vendor, &data, &len)) == -1) {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Get vendor attr failed: %s ",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Get vendor attr failed: %s ",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	  return RAD_NACK;
 	}
@@ -1641,7 +1649,7 @@
 		    auth->info.lnkname));
 		}
 		if ((tmpval = rad_cvt_string((const char *)data, len)) == NULL) {
-		    Log(LG_RADIUS, ("[%s] RADIUS: rad_cvt_string failed: %s",
+		    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_cvt_string failed: %s",
 			auth->info.lnkname, rad_strerror(auth->radius.handle)));
 		    return RAD_NACK;
 		}
@@ -1667,7 +1675,7 @@
 		  auth->info.lnkname));
 		tmpkey = rad_demangle_mppe_key(auth->radius.handle, data, len, &tmpkey_len);
 		if (!tmpkey) {
-		  Log(LG_RADIUS, ("[%s] RADIUS: rad_demangle_mppe_key failed: %s",
+		  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_demangle_mppe_key failed: %s",
 		    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 		  return RAD_NACK;
 		}
@@ -1682,7 +1690,7 @@
 		  auth->info.lnkname));
 		tmpkey = rad_demangle_mppe_key(auth->radius.handle, data, len, &tmpkey_len);
 		if (!tmpkey) {
-		  Log(LG_RADIUS, ("[%s] RADIUS: rad_demangle_mppe_key failed: %s",
+		  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_demangle_mppe_key failed: %s",
 		    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 		  return RAD_NACK;
 		}
@@ -1697,14 +1705,14 @@
 		  auth->info.lnkname));
 
 		if (len != 32) {
-		  Log(LG_RADIUS, ("[%s] RADIUS: Server returned garbage %d of expected %d Bytes",
+		  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Server returned garbage %d of expected %d Bytes",
 		    auth->info.lnkname, (int)len, 32));
 		  return RAD_NACK;
 		}
 
 		tmpkey = rad_demangle(auth->radius.handle, data, len);
 		if (tmpkey == NULL) {
-		  Log(LG_RADIUS, ("[%s] RADIUS: rad_demangle failed: %s",
+		  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_demangle failed: %s",
 		    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 		  return RAD_NACK;
 		}
@@ -1845,7 +1853,7 @@
 	      acl2 = strsep(&acl1, "#");
 	      i = atol(acl2);
 	      if (i <= 0 || i > ACL_FILTERS) {
-	        Log(LG_RADIUS, ("[%s] RADIUS: Wrong filter number: %i",
+	        Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Wrong filter number: %i",
 		  auth->info.lnkname, i));
 	        free(acl);
 	        break;
@@ -1966,7 +1974,7 @@
 	/* sanity check, this happens when FreeRADIUS has no msoft-dictionary loaded */
 	if (auth->proto == PROTO_CHAP && auth->alg == CHAP_ALG_MSOFTv2
 		&& auth->mschapv2resp == NULL && auth->status == AUTH_STATUS_SUCCESS) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: PANIC no MS-CHAP2-Success received from server!",
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: PANIC no MS-CHAP2-Success received from server!",
     		auth->info.lnkname));
 	    return RAD_NACK;
 	}
@@ -2003,7 +2011,7 @@
 	    j = 0;
 	    SLIST_FOREACH(r1, &auth->params.routes, next) {
 		if (!u_rangecompare(&r->dest, &r1->dest)) {
-		    Log(LG_RADIUS, ("[%s] RADIUS: Duplicate route", auth->info.lnkname));
+		    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Duplicate route", auth->info.lnkname));
 		    j = 1;
 		}
 	    };
diff -ur mpd-5.6/src/radius.h mpd-5.6-lutz/src/radius.h
--- mpd-5.6/src/radius.h	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/radius.h	2013-04-25 13:18:17.000000000 +0200
@@ -117,6 +117,7 @@
   #define RAD_MPD_IFACE_NAME	20
   #define RAD_MPD_IFACE_DESCR	21
   #define RAD_MPD_IFACE_GROUP	22
+  #define RAD_MPD_TERM_CAUSE	23
   #define RAD_MPD_DROP_USER	154
 
   /* Configuration options */
diff -ur mpd-5.6/src/radsrv.c mpd-5.6-lutz/src/radsrv.c
--- mpd-5.6/src/radsrv.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/radsrv.c	2013-04-24 11:34:31.000000000 +0200
@@ -239,7 +239,7 @@
 		break;
 	    case RAD_VENDOR_SPECIFIC:
 		if ((res = rad_get_vendor_attr(&vendor, &data, &len)) == -1) {
-		    Log(LG_RADIUS, ("radsrv: Get vendor attr failed: %s ",
+		    Log(LG_ERR|LG_RADIUS, ("radsrv: Get vendor attr failed: %s ",
 			rad_strerror(w->handle)));
 		    break;
 		}
@@ -312,7 +312,7 @@
 		          acl2 = strsep(&acl1, "#");
 		          i = atol(acl2);
 		          if (i <= 0 || i > ACL_FILTERS) {
-		            Log(LG_RADIUS, ("radsrv: Wrong filter number: %i", i));
+		            Log(LG_ERR|LG_RADIUS, ("radsrv: Wrong filter number: %i", i));
 		            free(acl);
 	    		    break;
 			  }
@@ -659,13 +659,13 @@
 	Log(LG_RADIUS2, ("radsrv: Adding client %s", s->hostname));
 	if (rad_add_server (w->handle, s->hostname,
 		0, s->sharedsecret, 0, 0) == -1) {
-		Log(LG_RADIUS, ("radsrv: Adding client error: %s",
+		Log(LG_ERR|LG_RADIUS, ("radsrv: Adding client error: %s",
 		    rad_strerror(w->handle)));
 	}
 	s = s->next;
     }
 
-    Log(LG_ERR, ("radsrv: listening on %s %d", 
+    Log(LG_ALWAYS, ("radsrv: listening on %s %d", 
 	u_addrtoa(&w->addr,addrstr,sizeof(addrstr)), w->port));
     return (0);
 }
@@ -686,7 +686,7 @@
     rad_close(w->handle);
     w->handle = NULL;
 
-    Log(LG_ERR, ("radsrv: stop listening"));
+    Log(LG_ALWAYS, ("radsrv: stop listening"));
     return (0);
 }
 
diff -ur mpd-5.6/src/rep.c mpd-5.6-lutz/src/rep.c
--- mpd-5.6/src/rep.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/rep.c	2013-04-24 11:31:36.000000000 +0200
@@ -36,11 +36,13 @@
     
     Log(LG_REP, ("[%s] Rep: INCOMING event from %s (0)",
 	r->name, l->name));
-	
+
+    MUTEX_LOCK(gNgMutex);
     if (r->csock <= 0) {
 	/* Create a new netgraph node to control TCP ksocket node. */
 	if (NgMkSockNode(NULL, &r->csock, NULL) < 0) {
     	    Perror("[%s] Rep: can't create control socket", r->name);
+	    MUTEX_UNLOCK(gNgMutex);
     	    PhysClose(l);
 	    return;
 	}
@@ -55,6 +57,7 @@
     	Perror("[%s] Rep: can't attach %s %s node",
     	    l->name, NG_TEE_NODE_TYPE, mkp.ourhook);
 	close(r->csock);
+   	MUTEX_UNLOCK(gNgMutex);
     	PhysClose(l);
 	return;
     }
@@ -63,10 +66,12 @@
     if ((r->node_id = NgGetNodeID(r->csock, ".:tee")) == 0) {
 	Perror("[%s] Rep: Cannot get %s node id", l->name, NG_TEE_NODE_TYPE);
 	close(r->csock);
+   	MUTEX_UNLOCK(gNgMutex);
     	PhysClose(l);
 	return;
     };
     
+    MUTEX_UNLOCK(gNgMutex);
     PhysGetCallingNum(r->links[0], buf, sizeof(buf));
     PhysSetCallingNum(r->links[1], buf);
 
@@ -97,11 +102,13 @@
     if (r->p_up == 3 && r->csock > 0 && r->node_id) {
 	char path[NG_PATHSIZ];
 	
+   	MUTEX_LOCK(gNgMutex);
 	snprintf(path, sizeof(path), "[%x]:", r->node_id);
 	NgFuncShutdownNode(r->csock, r->name, path);
 	r->node_id = 0;
 	close(r->csock);
 	r->csock = -1;
+   	MUTEX_UNLOCK(gNgMutex);
     }
 }
 
@@ -126,10 +133,12 @@
     if (r->csock > 0 && r->node_id) {
 	char path[NG_PATHSIZ];
 	
+   	MUTEX_LOCK(gNgMutex);
 	snprintf(path, sizeof(path), "[%x]:", r->node_id);
 	NgFuncShutdownNode(r->csock, r->name, path);
 	r->node_id = 0;
 	close(r->csock);
+   	MUTEX_UNLOCK(gNgMutex);
 	r->csock = -1;
     }
     
@@ -251,17 +260,17 @@
     int		k;
 
     if ((l = LinkFind(out)) == NULL) {
-	Log(LG_REP, ("[%s] Can't find link \"%s\"", in->name, out));
+	Log(LG_ERR|LG_REP, ("[%s] Can't find link \"%s\"", in->name, out));
 	return (-1);
     }
     if (PhysIsBusy(l)) {
-	Log(LG_REP, ("[%s] Link \"%s\" is busy", in->name, out));
+	Log(LG_ERR|LG_REP, ("[%s] Link \"%s\" is busy", in->name, out));
 	return (-1);
     }
     if (l->tmpl)
 	l = LinkInst(l, NULL, 0, 0);
     if (!l) {
-	Log(LG_REP, ("[%s] Can't create link \"%s\"", in->name, out));
+	Log(LG_ERR|LG_REP, ("[%s] Can't create link \"%s\"", in->name, out));
 	return (-1);
     }
 
@@ -310,10 +319,12 @@
     if (r->csock > 0 && r->node_id) {
 	char path[NG_PATHSIZ];
 	
+   	MUTEX_LOCK(gNgMutex);
 	snprintf(path, sizeof(path), "[%x]:", r->node_id);
 	NgFuncShutdownNode(r->csock, r->name, path);
 	r->node_id = 0;
 	close(r->csock);
+   	MUTEX_UNLOCK(gNgMutex);
 	r->csock = -1;
     }
     r->dead = 1;
diff -ur mpd-5.6/src/tcp.c mpd-5.6-lutz/src/tcp.c
--- mpd-5.6/src/tcp.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/tcp.c	2013-04-24 11:30:56.000000000 +0200
@@ -216,6 +216,7 @@
 	int 			rval;
 	char 			buf[48];
 
+   	MUTEX_LOCK(gNgMutex);
 	/* Create a new netgraph node to control TCP ksocket node. */
 	if (NgMkSockNode(NULL, &pi->csock, NULL) < 0) {
 		Perror("[%s] TCP can't create control socket", l->name);
@@ -224,7 +225,7 @@
 	(void)fcntl(pi->csock, F_SETFD, 1);
 
         if (!PhysGetUpperHook(l, path, hook)) {
-		Log(LG_PHYS, ("[%s] TCP: can't get upper hook", l->name));
+		Log(LG_ERR|LG_PHYS, ("[%s] TCP: can't get upper hook", l->name));
     		goto fail;
         }
     
@@ -343,8 +344,10 @@
 		    u_addrtoa(&pi->conf.peer_addr.addr, buf, sizeof(buf)), pi->conf.peer_port));
 	}
 
+   	MUTEX_UNLOCK(gNgMutex);
 	return;
 fail:
+   	MUTEX_UNLOCK(gNgMutex);
 	l->state = PHYS_STATE_DOWN;
 	TcpDoClose(l);
 	PhysDown(l, STR_ERROR, NULL);
@@ -371,6 +374,7 @@
 
 	assert(type == EVENT_READ);
 
+   	MUTEX_LOCK(gNgMutex);
 	/* Check whether the connection was successful or not. */
 	if (NgRecvMsg(pi->csock, &cn.resp, sizeof(cn), path) < 0) {
 		Perror("[%s] error reading message from \"%s\"", l->name, path);
@@ -381,7 +385,7 @@
 	assert(cn.resp.header.cmd == NGM_KSOCKET_CONNECT);
 
 	if (cn.rval != 0) {
-		Log(LG_PHYS, ("[%s] failed to connect: %s", l->name,
+		Log(LG_ERR|LG_PHYS, ("[%s] failed to connect: %s", l->name,
 		    strerror(cn.rval)));
 		goto failed;
 	}
@@ -389,11 +393,13 @@
 	/* Report connected. */
 	Log(LG_PHYS, ("[%s] connection established", l->name));
 
+   	MUTEX_UNLOCK(gNgMutex);
 	l->state = PHYS_STATE_UP;
 	PhysUp(l);
 
 	return;
 failed:
+   	MUTEX_UNLOCK(gNgMutex);
 	l->state = PHYS_STATE_DOWN;
 	TcpDoClose(l);
 	PhysDown(l, STR_ERROR, NULL);
@@ -423,6 +429,7 @@
 
 	assert(type == EVENT_READ);
 
+   	MUTEX_LOCK(gNgMutex);
 	/* Accept cloned ng_ksocket(4). */
 	if (NgRecvMsg(If->csock, &ac.resp, sizeof(ac), NULL) < 0) {
 		Perror("TCP: error reading message from \"%s\"", path);
@@ -495,11 +502,12 @@
 
 		PhysIncoming(l);
 	} else {
-	    Log(LG_PHYS, ("No free TCP link with requested parameters "
+	    Log(LG_ERR|LG_PHYS, ("No free TCP link with requested parameters "
 	        "was found"));
 	    snprintf(path, sizeof(path), "[%x]:", ac.id);
 	    NgFuncShutdownNode(If->csock, "", path);
 	}
+   	MUTEX_UNLOCK(gNgMutex);
 
 failed:
 	/* Tell that we are willing to receive accept message. */
@@ -507,6 +515,7 @@
 	    NGM_KSOCKET_ACCEPT, NULL, 0) < 0) {
 		Perror("TCP: can't accept on %s node", NG_KSOCKET_NODE_TYPE);
 	}
+   	MUTEX_UNLOCK(gNgMutex);
 	EventRegister(&If->ctrlEvent, EVENT_READ, If->csock,
 	    0, TcpAcceptEvent, If);
 }
@@ -566,6 +575,7 @@
 	    return;
 	};
 
+   	MUTEX_LOCK(gNgMutex);
 	if (pi->node_id != 0) {
 	    snprintf(path, sizeof(path), "[%lx]:", (u_long)pi->node_id);
 	    NgFuncShutdownNode(pi->csock, l->name, path);
@@ -579,6 +589,8 @@
 	}
 	
 	close(pi->csock);
+   	MUTEX_UNLOCK(gNgMutex);
+   
 	pi->csock = -1;
 	pi->node_id = 0;
 }
@@ -750,9 +762,11 @@
 	u_addrcopy(&pi->conf.self_addr,&pi->If->self_addr);
 	pi->If->self_port=pi->conf.self_port;
 	
+   	MUTEX_LOCK(gNgMutex);
 	/* Create a new netgraph node */
 	if (NgMkSockNode(NULL, &pi->If->csock, NULL) < 0) {
 	    Perror("TCP: can't create ctrl socket");
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(0);
 	}
 	(void)fcntl(pi->If->csock, F_SETFD, 1);
@@ -805,6 +819,7 @@
 
 	Log(LG_PHYS, ("TCP: waiting for connection on %s %u",
 	    u_addrtoa(&pi->If->self_addr, buf, sizeof(buf)), pi->If->self_port));
+   	MUTEX_UNLOCK(gNgMutex);
 	EventRegister(&pi->If->ctrlEvent, EVENT_READ, pi->If->csock,
 	    0, TcpAcceptEvent, pi->If);
 
@@ -812,6 +827,7 @@
 fail2:
 	NgSendMsg(pi->If->csock, LISTENHOOK, NGM_GENERIC_COOKIE, NGM_SHUTDOWN,
 	    NULL, 0);
+   	MUTEX_UNLOCK(gNgMutex);
 	return (0);
 }
 
diff -ur mpd-5.6/src/udp.c mpd-5.6-lutz/src/udp.c
--- mpd-5.6/src/udp.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/udp.c	2013-04-24 11:29:23.000000000 +0200
@@ -219,6 +219,7 @@
         struct ng_ksocket_sockopt *const ksso = &u.ksso;
 	int			csock;
 
+   	MUTEX_LOCK(gNgMutex);
 	/* Create a new netgraph node to control TCP ksocket node. */
 	if (NgMkSockNode(NULL, &csock, NULL) < 0) {
 		Perror("[%s] TCP can't create control socket", l->name);
@@ -227,7 +228,7 @@
 	(void)fcntl(csock, F_SETFD, 1);
 
         if (!PhysGetUpperHook(l, path, hook)) {
-		Log(LG_PHYS, ("[%s] UDP: can't get upper hook", l->name));
+		Log(LG_ERR, ("[%s] UDP: can't get upper hook", l->name));
     		goto fail;
         }
 
@@ -311,6 +312,7 @@
     }
   
     close(csock);
+    MUTEX_UNLOCK(gNgMutex);
 
     /* OK */
     l->state = PHYS_STATE_UP;
@@ -318,6 +320,7 @@
     return;
 
 fail:
+    MUTEX_UNLOCK(gNgMutex);
     UdpDoClose(l);
     pi->incoming=0;
     l->state = PHYS_STATE_DOWN;
@@ -378,9 +381,11 @@
 	if (pi->node_id == 0)
 		return;
 
+   	MUTEX_LOCK(gNgMutex);
 	/* Get a temporary netgraph socket node */
 	if (NgMkSockNode(NULL, &csock, NULL) == -1) {
 		Perror("UDP: NgMkSockNode");
+	   	MUTEX_UNLOCK(gNgMutex);
 		return;
 	}
 	
@@ -389,6 +394,7 @@
 	NgFuncShutdownNode(csock, l->name, path);
 	
 	close(csock);
+   	MUTEX_UNLOCK(gNgMutex);
 	
 	pi->node_id = 0;
 }
@@ -539,7 +545,7 @@
 
 	saddrlen = sizeof(saddr);
 	if ((pktlen = recvfrom(If->csock, pktbuf, sizeof(pktbuf), MSG_DONTWAIT, (struct sockaddr *)(&saddr), &saddrlen)) < 0) {
-	    Log(LG_PHYS, ("recvfrom() error: %s", strerror(errno)));
+	    Log(LG_ERR|LG_PHYS, ("recvfrom() error: %s", strerror(errno)));
 	}
 
 	sockaddrtou_addr(&saddr, &addr, &port);
@@ -600,7 +606,7 @@
 
 		PhysIncoming(l);
 	} else {
-		Log(LG_PHYS, ("No free UDP link with requested parameters "
+		Log(LG_ERR|LG_PHYS, ("No free UDP link with requested parameters "
 	    	    "was found"));
 	}
 
